*------------------------------------------------------------------------------
*-- Name....: C:\DBASE\PROGRAMS\FEMA\u_SYSDEF.PRG
*-- Author.....: Bill Ferguson
*--              BF Computer Solutions
*--              391 E. 118th Pl.
*--              Northglenn, CO 80233
*-- Date....: 5-04-90
*-- Version.: dBASE IV, Procedure for Format 1.1
*-- Notes...: Procedure file for VALID POPUPs and/or Context Sensitive Help
*-- ........: for SYSDEF.FMT
*------------------------------------------------------------------------------
PROCEDURE S_sysdef  && Open files and Define POPUPs
  USE Printers  ORDER Make_model IN 2 AGAIN

  DEFINE POPUP u_ FROM 4,31 ;
    TO 21,74 ;
    PROMPT FIELD  ;
    MESSAGE "Select from list using ENTER, cancel selection with ESC"

  ON SELECTION POPUP u_ DEACTIVATE POPUP

  SELECT 1

*-- EOP: s_SYSDEF
RETURN

*------------------------------------------------------------------------------
PROCEDURE C_sysdef  && Close files and Release POPUPs
  USE IN 2

  RELEASE POPUP u_

  SELECT 1

*-- EOP: c_SYSDEF
RETURN

*------------------------------------------------------------------------------
FUNCTION Empty                && Determine if the passed argument is NULL
PARAMETER x
  mtype = TYPE("x")
  DO CASE
    CASE mtype = "C"
      retval = (LEN(TRIM(x))=0)
    CASE mtype$"NF"
      retval = (x=0)
    CASE mtype = "D"
      retval = (" "$DTOC(x))
  ENDCASE
*-- EOP: empty
RETURN (retval)

*------------------------------------------------------------------------------
FUNCTION U_make_m
PARAMETER fld_name

  EscKey = 27                          && 27 represents the ESC key

  SELECT 2                       && Select the lookup file

  SEEK TRIM(fld_name)
  IF .NOT. FOUND()

      SAVE SCREEN TO temp
      DO shadowg WITH 4,31,21,74
      ACTIVATE POPUP u_
      RESTORE SCREEN FROM temp

      IF LASTKEY() <> EscKey 
        rtn_fld = PROMPT()
        @ 3,31 GET rtn_fld PICTURE "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" 
        CLEAR GETS

        REPLACE A->Make_model WITH rtn_fld

        SELECT 1
        RETURN (.T.)
      ELSE
        SELECT 1
        RETURN (.F.)
      ENDIF           

  ELSE
      SELECT 1
      RETURN (.T.)
  ENDIF

  SELECT 1                             && Go back to the edit file

*-- EOP: U_make_m
RETURN (.F.)

*------------------------------------------------------------------------------

PROCEDURE S_help
   *-- Opens the HELP .dbf file
   PUBLIC lc_cat, lc_dbf, lc_order, t, l, b, r
   t = 5
   l = 6
   b = 15
   r = 74
   DEFINE WINDOW z_help FROM t+1,l+1 TO b-1,r-1 NONE
   ON KEY LABEL F3 DO Toggle
   ON ERROR mvar=error()
   SELECT 10
   lc_cat = SET("CATALOG")
   lc_dbf = DBF()                                  && Grab dbf if any
   lc_order = ORDER()                              && Same for ORDER
   USE C:\DBASE\PROGRAMS\FEMA\SYSDEF_H ORDER fld_name NOUPDATE          && Open HELP .dbf
   SELECT 1
RETURN
*-- EOP: s_Help

*------------------------------------------------------------------------------
PROCEDURE C_help
   *-- Closes the HELP .dbf file
   USE IN 10
   IF lc_cat = "ON"
      SET CATALOG TO (lc_dbf)
   ELSE
      SELECT 10
      IF "" <> lc_dbf                                 && If there was a dbf reopen it
         USE (lc_dbf) 
      ENDIF
      IF "" <> lc_order
         SET ORDER TAG &lc_order.                     && Same for index.
      ENDIF
   ENDIF
   ON KEY LABEL F3
   RELEASE WINDOW z_help
   ON ERROR
   RELEASE lc_cat, lc_dbf, lc_order, t, l, b, r
   SELECT 1
RETURN
*-- EOP: c_Help

*------------------------------------------------------------------------------
PROCEDURE Help
   *-- Activates the HELP window
   PARAMETER lc_var
   SELECT 10
   SEEK lc_var
   IF FOUND()                                      && If found show Help
      SAVE SCREEN TO zz_help
      DO shadowg WITH t,l,b,r
      @ t,l TO b,r DOUBLE
      ln_memline = SET("MEMO")
      SET MEMOWIDTH TO 65
      IF MEMLINES(fld_help) > 9
         @ t+1,r SAY CHR(24)
         @ b-1,r SAY CHR(25)
      ENDIF
      lc_string = [ Help for ] + TRIM(fld_headng) +[ ]
      @ t,CENTER(lc_string,80) SAY lc_string
      @ 0,0 GET fld_help OPEN WINDOW z_help ;
         MESSAGE "Scroll thru Help: Ctrl-Home   Exit Viewing Help: Ctrl-End   See Org. Screen: F3"
      READ
      SET MEMOWIDTH TO ln_memline
      RESTORE SCREEN FROM zz_help
      RELEASE SCREEN zz_help
   ENDIF
   SET MESSAGE TO
   SELECT 1                                        && Back to edit work area
RETURN
*-- EOP: HELP

*------------------------------------------------------------------------------
PROCEDURE Toggle
   *-- Toggles the Help message back to the original screen
   SAVE SCREEN to Toggle
   RESTORE SCREEN FROM zz_help
   SET MESSAGE TO "Press any key..."
   mwait = INKEY(15)
   RESTORE SCREEN FROM Toggle
   RELEASE SCREEN Toggle
   SET MESSAGE TO "Scroll thru Help: Ctrl-Home   Exit Viewing Help: Ctrl-End   See Org. Screen: F3"
RETURN
*-- EOP: Toggle

*------------------------------------------------------------------------------
FUNCTION Center
*-- UDF to center a string.
*-- lc_string = String to center
*-- ln_width = Width of screen to center in
*--
*-- Ex. @ 15,center(string,80) say string
*-- Will center the <string> within 80 columns
PARAMETER lc_string, ln_width
RETURN ((ln_width/2)-(LEN(lc_string)/2))
*------------------------------------------------------------------------------
PROCEDURE Shadow                        && displays shadow
PARAMETER x1,y1,x2,y2,dfill

  IF dfill                              && use fill command not window

    @ x1+1,y1+2 FILL TO x2+1,y2+2 COLOR n+/n

  ELSE                                  && define shadow window

    DEFINE WINDOW shadow_win FROM x1+1,y1+2 TO x2+1,y2+2 none color n+/n
    ACTIVATE WINDOW shadow_win

  ENDIF

RETURN
*-- EOP: shadow

*------------------------------------------------------------------------------
PROCEDURE Shadowg                       && displays shadow that grows
PARAMETER x1,y1,x2,y2
* x1 = Top Right Corner
* y1 = Top Left  Corner
* x2 = Bottom Right Corner
* x3 = Bottom Left  Corner


  x0 = x2+1
  y0 = y2+2
  dx = 1
  dy = (y2-y1) / (x2-x1)
  DO WHILE x0 <> x1 .OR. y0 <> y1+2

    @ x0,y0 FILL TO x2+1,y2+2 COLOR n+/n
    x0 = IIF(x0<>x1,x0 - dx,x0)
    y0 = IIF(y0<>y1+2,y0 - dy,y0)
    y0 = IIF(y0<y1+2,y1+2,y0)
  ENDDO

RETURN
*-- EOP: shadowg
